# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_0
  module Models
    #
    # Management policy for a certificate.
    #
    class CertificatePolicy

      include MsRestAzure

      # @return [String] The certificate id.
      attr_accessor :id

      # @return [KeyProperties] Properties of the key backing a certificate.
      attr_accessor :key_properties

      # @return [SecretProperties] Properties of the secret backing a
      # certificate.
      attr_accessor :secret_properties

      # @return [X509CertificateProperties] Properties of the X509 component of
      # a certificate.
      attr_accessor :x509certificate_properties

      # @return [Array<LifetimeAction>] Actions that will be performed by Key
      # Vault over the lifetime of a certificate.
      attr_accessor :lifetime_actions

      # @return [IssuerParameters] Parameters for the issuer of the X509
      # component of a certificate.
      attr_accessor :issuer_parameters

      # @return [CertificateAttributes] The certificate attributes.
      attr_accessor :attributes


      #
      # Mapper for CertificatePolicy class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CertificatePolicy',
          type: {
            name: 'Composite',
            class_name: 'CertificatePolicy',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              key_properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'key_props',
                type: {
                  name: 'Composite',
                  class_name: 'KeyProperties'
                }
              },
              secret_properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'secret_props',
                type: {
                  name: 'Composite',
                  class_name: 'SecretProperties'
                }
              },
              x509certificate_properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'x509_props',
                type: {
                  name: 'Composite',
                  class_name: 'X509CertificateProperties'
                }
              },
              lifetime_actions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lifetime_actions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'LifetimeActionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'LifetimeAction'
                      }
                  }
                }
              },
              issuer_parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'issuer',
                type: {
                  name: 'Composite',
                  class_name: 'IssuerParameters'
                }
              },
              attributes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'attributes',
                type: {
                  name: 'Composite',
                  class_name: 'CertificateAttributes'
                }
              }
            }
          }
        }
      end
    end
  end
end
