# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_1
  module Models
    #
    # The secret management attributes.
    #
    class SecretAttributes < Attributes

      include MsRestAzure

      # @return [Integer] softDelete data retention days. Value should be >=7
      # and <=90 when softDelete enabled, otherwise 0.
      attr_accessor :recoverable_days

      # @return [DeletionRecoveryLevel] Reflects the deletion recovery level
      # currently in effect for secrets in the current vault. If it contains
      # 'Purgeable', the secret can be permanently deleted by a privileged
      # user; otherwise, only the system can purge the secret, at the end of
      # the retention interval. Possible values include: 'Purgeable',
      # 'Recoverable+Purgeable', 'Recoverable',
      # 'Recoverable+ProtectedSubscription', 'CustomizedRecoverable+Purgeable',
      # 'CustomizedRecoverable', 'CustomizedRecoverable+ProtectedSubscription'
      attr_accessor :recovery_level


      #
      # Mapper for SecretAttributes class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SecretAttributes',
          type: {
            name: 'Composite',
            class_name: 'SecretAttributes',
            model_properties: {
              enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enabled',
                type: {
                  name: 'Boolean'
                }
              },
              not_before: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nbf',
                type: {
                  name: 'UnixTime'
                }
              },
              expires: {
                client_side_validation: true,
                required: false,
                serialized_name: 'exp',
                type: {
                  name: 'UnixTime'
                }
              },
              created: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'created',
                type: {
                  name: 'UnixTime'
                }
              },
              updated: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'updated',
                type: {
                  name: 'UnixTime'
                }
              },
              recoverable_days: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'recoverableDays',
                type: {
                  name: 'Number'
                }
              },
              recovery_level: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'recoveryLevel',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
