# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_2_preview
  module Models
    #
    # Full backup operation
    #
    class FullBackupOperation

      include MsRestAzure

      # @return [String] Status of the backup operation.
      attr_accessor :status

      # @return [String] The status details of backup operation.
      attr_accessor :status_details

      # @return [Error] Error encountered, if any, during the full backup
      # operation.
      attr_accessor :error

      # @return The start time of the backup operation in UTC
      attr_accessor :start_time

      # @return The end time of the backup operation in UTC
      attr_accessor :end_time

      # @return [String] Identifier for the full backup operation.
      attr_accessor :job_id

      # @return [String] The Azure blob storage container Uri which contains
      # the full backup
      attr_accessor :azure_storage_blob_container_uri


      #
      # Mapper for FullBackupOperation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'FullBackupOperation',
          type: {
            name: 'Composite',
            class_name: 'FullBackupOperation',
            model_properties: {
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              status_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'statusDetails',
                type: {
                  name: 'String'
                }
              },
              error: {
                client_side_validation: true,
                required: false,
                serialized_name: 'error',
                type: {
                  name: 'Composite',
                  class_name: 'Error'
                }
              },
              start_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'startTime',
                type: {
                  name: 'UnixTime'
                }
              },
              end_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'endTime',
                type: {
                  name: 'UnixTime'
                }
              },
              job_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'jobId',
                type: {
                  name: 'String'
                }
              },
              azure_storage_blob_container_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'azureStorageBlobContainerUri',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
