# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_2_preview
  module Models
    #
    # The SAS definition management attributes.
    #
    class SasDefinitionAttributes

      include MsRestAzure

      # @return [Boolean] the enabled state of the object.
      attr_accessor :enabled

      # @return Creation time in UTC.
      attr_accessor :created

      # @return Last updated time in UTC.
      attr_accessor :updated

      # @return [Integer] softDelete data retention days. Value should be >=7
      # and <=90 when softDelete enabled, otherwise 0.
      attr_accessor :recoverable_days

      # @return [DeletionRecoveryLevel] Reflects the deletion recovery level
      # currently in effect for SAS definitions in the current vault. If it
      # contains 'Purgeable' the SAS definition can be permanently deleted by a
      # privileged user; otherwise, only the system can purge the SAS
      # definition, at the end of the retention interval. Possible values
      # include: 'Purgeable', 'Recoverable+Purgeable', 'Recoverable',
      # 'Recoverable+ProtectedSubscription', 'CustomizedRecoverable+Purgeable',
      # 'CustomizedRecoverable', 'CustomizedRecoverable+ProtectedSubscription'
      attr_accessor :recovery_level


      #
      # Mapper for SasDefinitionAttributes class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SasDefinitionAttributes',
          type: {
            name: 'Composite',
            class_name: 'SasDefinitionAttributes',
            model_properties: {
              enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enabled',
                type: {
                  name: 'Boolean'
                }
              },
              created: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'created',
                type: {
                  name: 'UnixTime'
                }
              },
              updated: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'updated',
                type: {
                  name: 'UnixTime'
                }
              },
              recoverable_days: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'recoverableDays',
                type: {
                  name: 'Number'
                }
              },
              recovery_level: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'recoveryLevel',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
