# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_2_preview
  module Models
    #
    # Model object.
    #
    #
    class SecurityDomainJsonWebKey

      include MsRestAzure

      # @return [String] Key identifier.
      attr_accessor :kid

      # @return [String] JsonWebKey Key Type (kty), as defined in
      # https://tools.ietf.org/html/draft-ietf-jose-json-web-algorithms-40. For
      # Security Domain this value must be RSA.
      attr_accessor :kty

      # @return [Array<String>]
      attr_accessor :key_ops

      # @return [String] RSA modulus.
      attr_accessor :n

      # @return [String] RSA public exponent.
      attr_accessor :e

      # @return [Array<String>] X509 certificate chain parameter
      attr_accessor :x5c

      # @return [String] Public Key Use Parameter. This is optional and if
      # present must be enc.
      attr_accessor :use

      # @return [String] X509 certificate SHA1 thumbprint. This is optional.
      attr_accessor :x5t

      # @return [String] X509 certificate SHA256 thumbprint.
      attr_accessor :x5t_s256

      # @return [String] Algorithm intended for use with the key.
      attr_accessor :alg


      #
      # Mapper for SecurityDomainJsonWebKey class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SecurityDomainJsonWebKey',
          type: {
            name: 'Composite',
            class_name: 'SecurityDomainJsonWebKey',
            model_properties: {
              kid: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kid',
                type: {
                  name: 'String'
                }
              },
              kty: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kty',
                type: {
                  name: 'String'
                }
              },
              key_ops: {
                client_side_validation: true,
                required: true,
                serialized_name: 'key_ops',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              n: {
                client_side_validation: true,
                required: true,
                serialized_name: 'n',
                type: {
                  name: 'String'
                }
              },
              e: {
                client_side_validation: true,
                required: true,
                serialized_name: 'e',
                type: {
                  name: 'String'
                }
              },
              x5c: {
                client_side_validation: true,
                required: true,
                serialized_name: 'x5c',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              use: {
                client_side_validation: true,
                required: false,
                serialized_name: 'use',
                type: {
                  name: 'String'
                }
              },
              x5t: {
                client_side_validation: true,
                required: false,
                serialized_name: 'x5t',
                type: {
                  name: 'String'
                }
              },
              x5t_s256: {
                client_side_validation: true,
                required: true,
                serialized_name: 'x5t#S256',
                type: {
                  name: 'String'
                }
              },
              alg: {
                client_side_validation: true,
                required: true,
                serialized_name: 'alg',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
